import es

es.load("myo_achievement")
achievementManager = es.import_addon("myo_achievement")
    
#Kill achievements
killAchievements = achievementManager.AddAchievementGroup("basicKills", "Basic Achievements - Kills", "This is a basic set of achievements for kills.")
killAchievements["kills1"] = ("Killer Novice", "Kill 200 enemies.", 200)
killAchievements["kills2"] = ("Killer Pro", "Kill 500 enemies.", 500)
killAchievements["kills3"] = ("Killer Expert", "Kill 1000 enemies.", 1000)

#Knife kill achievements
killAchievements["knifeKill1"] = ("Knife Novice", "Kill with a knife 20 times.", 20)
killAchievements["knifeKill2"] = ("Knife Pro", "Kill with a knife 50 times.", 50)
killAchievements["knifeKill3"] = ("Knife Expert", "Kill with a knife 100 times.", 100)

#HE grenade kill achievements
killAchievements["hegrenadeKill1"] = ("Grenade Novice", "Kill with an HE grenade 20 times.", 20)
killAchievements["hegrenadeKill2"] = ("Grenade Pro", "Kill with an HE grenade 50 times.", 50)
killAchievements["hegrenadeKill3"] = ("Grenade Expert", "Kill with an HE grenade 100 times.", 100)

#Flashbang and smoke grenade kill achievements
killAchievements["flashbangKill"] = ("Flash Killer", "Kill with a flashbang.", 1)
killAchievements["smokegrenadeKill"] = ("Smoke Killer", "Kill with a smoke grenade.", 1)

#Kill streak achievements
killAchievements["killStreak1"] = ("Kill Streak Novice", "Complete a kill streak of 5.", 5)
killAchievements["killStreak2"] = ("Kill Streak Pro", "Complete a kill streak of 10.", 10)
killAchievements["killStreak3"] = ("Kill Streak Expert", "Complete a kill streak of 20.", 20)

#Hostage rescued achievements
hostageAchievements = achievementManager.AddAchievementGroup("basicHostages", "Basic Achievements - Hostages", "This is a basic set of achievements for hostages.")
hostageAchievements["hostageRescue1"] = ("Rescue Novice", "Rescue 20 hostages.", 20)
hostageAchievements["hostageRescue2"] = ("Rescue Pro", "Rescue 50 hostages.", 50)
hostageAchievements["hostageRescue3"] = ("Rescue Expert", "Rescue 100 hostages.", 100)

#Bomb plant achievements
bombAchievements = achievementManager.AddAchievementGroup("basicBombs", "Basic Achievements - Bombs", "This is a basic set of achievements for bombs.")
bombAchievements["bombPlant1"] = ("Bomber Novice", "Plant the bomb 10 times.", 10)
bombAchievements["bombPlant2"] = ("Bomber Pro", "Plant the bomb 20 times.", 20)
bombAchievements["bombPlant3"] = ("Bomber Expert", "Plant the bomb 50 times.", 50)

#Bomb defuse achievements
bombAchievements["bombDefuse1"] = ("Defusal Novice", "Defuse the bomb 10 times.", 10)
bombAchievements["bombDefuse2"] = ("Defusal Pro", "Defuse the bomb 20 times.", 20)
bombAchievements["bombDefuse3"] = ("Defusal Expert", "Defuse the bomb 50 times.", 50)

#Suicide achievements
sillyAchievements = achievementManager.AddAchievementGroup("basicSilly", "Basic Achievements - Silly", "This is a basic set of achievements for silly achievements.")
sillyAchievements["suicide1"] = ("Suicide Novice", "Commit suicide 10 times.", 10)
sillyAchievements["suicide2"] = ("Suicide Pro", "Commit suicide 20 times.", 20)
sillyAchievements["suicide3"] = ("Suicide Export", "Commit suicide 50 times.", 50)

#Headshot achievements
hsAchievements = achievementManager.AddAchievementGroup("basicHeadshot", "Basic Achievements - Headshots", "This is a basic set of achievements for headshots.")
hsAchievements["hs1"] = ("Headshot Novice", "Kill 100 people with a headshot.", 100)
hsAchievements["hs2"] = ("Headshot Pro", "Kill 200 people with a headshot.", 200)
hsAchievements["hs3"] = ("Headshot Expert", "Kill 500 people with a headshot.", 500)

def player_death(ev):
    if ev['userid'] == ev['attacker'] or ev['attacker'] == "0":
        #Suicide achievements
        for ach in ("suicide1", "suicide2", "suicide3"):
            sillyAchievements[ach].stepProgressForPlayer(ev['userid'])
    else:
        if not ev['es_attackerteam'] == ev['es_userteam']:
            #Kill achievements
            for ach in ("kills1", "kills2", "kills3"):
                killAchievements[ach].stepProgressForPlayer(ev['attacker'])
            
            #Kill streak achievements
            for ach in ("killStreak1", "killStreak2", "killStreak3"):
                killAchievements[ach].stepProgressForPlayer(ev['attacker'])            
                if not killAchievements[ach].isPlayerCompleted(ev['userid']):
                    killAchievements[ach].resetProgressForPlayer(ev['userid'])
                
            if ev['weapon'] in ("knife", "hegrenade"):
                #Knife and HE grenade kill achievements
                for ach in ("%sKill1", "%sKill2", "%sKill3"):
                    killAchievements[ach % ev['weapon']].stepProgressForPlayer(ev['attacker'])
                
            elif ev['weapon'] in ("flashbang", "smokegrenade"):
                #Flashbang and smoke grenade kill achievements
                killAchievements["%sKill" % ev['weapon']].stepProgressForPlayer(ev['attacker'])
                
            if ev['headshot'] == '1':
                for ach in ("hs1", "hs2", "hs3"):
                    hsAchievements[ach].stepProgressForPlayer(ev['attacker'])

def bomb_planted(ev):
    #Bomb planted achievements
    for ach in ("bombPlant1", "bombPlant2", "bombPlant3"):
        bombAchievements[ach].stepProgressForPlayer(ev['userid'])

def bomb_defused(ev):
    #Bomb defused achievements
    for ach in ("bombDefuse1", "bombDefuse2", "bombDefuse3"):
        bombAchievements[ach].stepProgressForPlayer(ev['userid'])

def hostage_rescued(ev):
    #Hostage resuced achievements
    for ach in ("hostageRescue1", "hostageRescue2", "hostageRescue3"):
        hostageAchievements[ach].stepProgressForPlayer(ev['userid'])